-- Servant = {model = 0}

-- function Servant:new (o)
  -- o = o or {}
  -- setmetatable(o, self)
  -- self.__index = self
  
  -- self.model = load3DModel('models/obj_player_robot/player_frame1.obj')
  -- return o
-- end

-- function Servant:manage ()
-- end

-- function Servant:draw ()
	-- draw3DModel(self.model)
-- end

-- function Servant:delete()
	-- unload3DModel(self.model)
-- end

model_Servant = 0

Servant = {

	load = function()
		model_Servant = load3DModel('models/obj_player_robot/player_frame1.obj')
	end,

	manage = function()
	
		-----------
		
		-- if is_showing_the_way then
			-- for index,pos in pairs(tablePositions) do
				-- x = pos[1]
				-- y = pos[2]
				-- z = pos[3]
				-- setObjectLocalVariablePos(index,x,y,z)
			-- end
			-- setObjectLocalVariable("table_index", 1)
			-- setObjectLocalVariable("table_is_reverse", 0)
			-- setObjectLocalVariable("table_size", table.getn( tablePositions )-1)
			-- is_showing_the_way = false
		-- end
		
		-----------
		
		-- local table_index = getObjectLocalVariable("table_index")
		-- local table_is_reverse = getObjectLocalVariable("table_is_reverse")
		-- local table_size = getObjectLocalVariable("table_size")
		
		-- local x,y,z = getObjectLocalVariablePos(table_index)
		-- setCurrentObjectPosition(x,y,z)
		
		-- if table_is_reverse == 1 then
			-- setObjectLocalVariable("table_index", table_index - 1)
			-- if table_index < 1 then
				-- setObjectLocalVariable("table_is_reverse", 0)
				-- setObjectLocalVariable("table_index", 2)
			-- end
		-- else
			-- setObjectLocalVariable("table_index", table_index + 1)
			-- if table_index > table_size then
				-- setObjectLocalVariable("table_is_reverse", 1)
				-- setObjectLocalVariable("table_index", table_size)
			-- end
		-- end
	end,

	draw = function()
		draw3DModel(model_Servant)
	end,
	
	unload = function()
		unload3DModel(model_Servant)
	end
}

----------------------------------------------------------------------------------------------------------------

MagicSphere = {

	model_magic_sphere = 0,

	load = function() model_magic_sphere = load3DModel('models/obj_magic_sphere/magic_sphere.obj') end,
	
	manage = function()
		if getDistanceToPlayer() < 15 and getTime() > last_load_or_save_time + 1000 and not isEditorMode() then
			callSaveGame()
			description = 'Game saved.'
			time_description = 1000 + getTime()
			last_load_or_save_time = getTime()
		end
	end,
	
	draw = function()
		if getTime() > last_load_or_save_time + 1000 then
			draw3DModel(model_magic_sphere)
		end
	end,
	
	unload = function()
		unload3DModel(model_magic_sphere)
	end
}

----------------------------------------------------------------------------------------------------------------

CubeEnd = {

	model_end_cube = 0,

	load = function()
		model_end_cube = load3DModel('models/obj_cube_end/cube_end.obj')
	end,

	manage = function()
		if getDistanceToPlayer() < 15.0 then
			is_game_over = 1
		end
	end,

	draw = function()
		draw3DModel(model_end_cube)
	end,
	
	unload = function()
		unload3DModel(model_end_cube)
	end
}

----------------------------------------------------------------------------------------------------------------

Projectile = {

	model_projectile = 0,
	
	load = function()
		model_projectile = load3DModel('models/obj_magic_sphere/magic_sphere.obj')
	end,
		
	manage = function()
		local v1,v2,v3,v4,v5 = getObjectLocalVariables()
		--print (v1..','..v2..','..v3..','..v4..','..v5)
		if v4 == 0 then --initialization
			local angle_x, angle_y, dist = getCameraAngleAndDistance()
			v1, v2, v3 = cartesianCoordFromSphericalCoord(angle_x,angle_y, 2.0)
			v4=1
		end
		local duration = getPeriodDuration()/100
		local x,y,z = getCurrentObjectPosition()
		for i = 0, duration, 1 do
			v2=v2-0.00005
			setCurrentObjectPosition(x+v1,y+v2,z+v3)
		end
		local x,y,z = getCurrentObjectPosition()
		local cube_type, x_center,y_center, z_center, width, height, depth = getCollidingCubeInfos(x,y,z)
		if cube_type > -1 and v4 == 1 then
			removeCubesSphericalHole(x,y,z, 90)
			autoDestroyCurrentObject()
		elseif y < -100 then
			autoDestroyCurrentObject()
		end
		setObjectLocalVariables(v1,v2,v3,v4,v5)
	end,
	
	draw = function()
		draw3DModel(model_projectile)
	end,
	
	unload = function()
		unload3DModel(model_projectile)
	end
}




--if getKeyNoRepeat('u') then
--	local x,y,z=getPlayerPositionReal()
--	createObject(x,y+5,z,1)
--end